# knife download

The knife download subcommand is used to download roles, cookbooks, environments, nodes, and data bags from the server to the current working directory. It can be used to back up data on the server, inspect the state of one or more files, or to extract out-of-process changes users may have made to files on the server, such as if a user made a change that bypassed version source control. This subcommand is often used in conjunction with `knife diff`, which can be used to see exactly what changes will be downloaded, and then `knife upload`, which does the opposite of `knife download`.

## Syntax

This argument has the following syntax:

    $ knife download [PATTERN...] (options)

## Options

Note

Review the list of common options available to this (and all) Knife subcommands and plugins.

This subcommand has the following options:

`--chef-repo-path PATH`
  The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by `chef_repo_path` in config.rb.
`--concurrency`
  The number of allowed concurrent connections. Default: `10`.
`--cookbook-version VERSION`
  The version of a cookbook to be downloaded.
`--[no-]force`
  Use `--force` to download files even when the file on the hard drive is identical to the object on the server (role, cookbook, etc.). By default, files are compared to see if they have equivalent content, and local files are only overwritten if they are different. Default: `--no-force`.
`-n`, `--dry-run`
  Indicates that no action is taken and that results are only printed out. Default: `false`.
`--[no-]diff`
  Indicates that only new and modified files will be downloaded. Set to `false` to download all files. Default: `--diff`.
`--[no-]recurse`
  Use `--no-recurse` to disable downloading a directory recursively. Default: `--recurse`.
`--[no-]purge`
  Use `--purge` to delete local files and directories that do not exist on the server. By default, if a role, cookbook, etc. does not exist on the server, the local file for said role will be left alone and NOT deleted. Default: `--no-purge`.
`--repo-mode MODE`
  The layout of the local chef-repo. Possible values: `static`, `everything`, or `hosted_everything`. Use `static` for just roles, environments, cookbooks, and data bags. By default, `everything` and `hosted_everything` are dynamically selected depending on the server type. Default: `everything` / `hosted_everything`.

## Examples

The following examples show how to use this Knife subcommand:

Download the entire chef-repo

To download the entire chef-repo from the server, browse to the top level of the chef-repo and enter:

    $ knife download /

Download the /cookbooks directory

To download the `cookbooks/` directory from the server, browse to the top level of the chef-repo and enter:

    $ knife download cookbooks

or from anywhere in the chef-repo, enter:

    $ knife download /cookbooks

Download the /environments directory

To download the `environments/` directory from the server, browse to the top level of the chef-repo and enter:

    $ knife download environments

or from anywhere in the chef-repo, enter:

    $ knife download /environments

Download an environment

To download an environment named “production” from the server, browse to the top level of the chef-repo and enter:

    $ knife download environments/production.json

or from the `environments/` directory, enter:

    $ knife download production.json

Download the /roles directory

To download the `roles/` directory from the server, browse to the top level of the chef-repo and enter:

    $ knife download roles

or from anywhere in the chef-repo, enter:

    $ knife download /roles

Download cookbooks and roles

To download all cookbooks that start with “apache” and belong to the “webserver” role, browse to the top level of the chef-repo and enter:

    $  knife download cookbooks/apache\* roles/webserver.json